diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/setfileno.c libg++-2.5.3linux.2/libio/stdio/setfileno.c
*** libg++-2.5.3/libio/stdio/setfileno.c	Fri Nov 26 21:48:33 1993
--- libg++-2.5.3linux.2/libio/stdio/setfileno.c	Tue Jan 18 11:20:59 1994
***************
*** 11,16 ****
--- 11,17 ----
       _IO_FILE* fp;
       int fd;
  {
+   CHECK_FILE(fp, );
    COERCE_FILE(fp);
    if ((fp->_flags & _IO_IS_FILEBUF) != 0)
      fp->_fileno = fd;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/stdio.c libg++-2.5.3linux.2/libio/stdio/stdio.c
*** libg++-2.5.3/libio/stdio/stdio.c	Wed Dec 31 19:00:00 1969
--- libg++-2.5.3linux.2/libio/stdio/stdio.c	Mon Dec 20 08:54:34 1993
***************
*** 0 ****
--- 1,12 ----
+ #include "libioP.h"
+ #include "stdio.h"
+ 
+ /* Define non-macro versions of stdin/stdout/stderr,
+  * for use by debuggers. */
+ 
+ #undef stdin
+ #undef stdout
+ #undef stderr
+ FILE* stdin = &_IO_stdin_._file;
+ FILE* stdout = &_IO_stdout_._file;
+ FILE* stderr = &_IO_stderr_._file;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/stdio.h libg++-2.5.3linux.2/libio/stdio/stdio.h
*** libg++-2.5.3/libio/stdio/stdio.h	Mon Oct  4 20:40:07 1993
--- libg++-2.5.3linux.2/libio/stdio/stdio.h	Mon Dec 20 08:58:12 1993
***************
*** 19,25 ****
  */
  #ifndef _STDIO_H
  #define _STDIO_H
! #define _STDIO_USES_IOSTREAM
  
  #include <libio.h>
  
--- 19,30 ----
  */
  #ifndef _STDIO_H
  #define _STDIO_H
! #undef _STDIO_USES_IOSTREAM
! #define _STDIO_USES_IOSTREAM 1
! 
! #ifdef __linux__
! #include <features.h>
! #endif
  
  #include <libio.h>
  
***************
*** 68,74 ****
  
  #define FOPEN_MAX     _G_FOPEN_MAX
  #define FILENAME_MAX _G_FILENAME_MAX
! #define TMP_MAX 999 /* Only limited by filename length */
  
  #define L_ctermid     9
  #define L_cuserid     9
--- 73,82 ----
  
  #define FOPEN_MAX     _G_FOPEN_MAX
  #define FILENAME_MAX _G_FILENAME_MAX
! 
! /* limited by the number of possible unique combinations. see
!  * libio/iotempname.c for details. */
! #define TMP_MAX 238328
  
  #define L_ctermid     9
  #define L_cuserid     9
***************
*** 82,154 ****
  #define stdout _IO_stdout
  #define stderr _IO_stderr
  
! #define getc(fp) _IO_getc(fp)
! #define putc(c, fp) _IO_putc(c, fp)
! #define putchar(c) putc(c, stdout)
! #define getchar() getc(stdin)
  
! #ifdef __cplusplus
! extern "C" {
! #endif
  
! #if defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
! #define _ARGS(args) args
! #else
! #define _ARGS(args) ()
  #endif
  
! extern void clearerr _ARGS((FILE*));
! extern int fclose _ARGS((FILE*));
! extern int feof _ARGS((FILE*));
! extern int ferror _ARGS((FILE*));
! extern int fflush _ARGS((FILE*));
! extern int fgetc _ARGS((FILE *));
! extern int fgetpos _ARGS((FILE* fp, fpos_t *pos));
! extern char* fgets _ARGS((char*, int, FILE*));
! extern FILE* fopen _ARGS((const char*, const char*));
! extern int fprintf _ARGS((FILE*, const char* format, ...));
! extern int fputc _ARGS((int, FILE*));
! extern int fputs _ARGS((const char *str, FILE *fp));
! extern size_t fread _ARGS((void*, size_t, size_t, FILE*));
! extern FILE* freopen _ARGS((const char*, const char*, FILE*));
! extern int fscanf _ARGS((FILE *fp, const char* format, ...));
! extern int fseek _ARGS((FILE* fp, long int offset, int whence));
! extern int fsetpos _ARGS((FILE* fp, const fpos_t *pos));
! extern long int ftell _ARGS((FILE* fp));
! extern size_t fwrite _ARGS((const void*, size_t, size_t, FILE*));
! extern char* gets _ARGS((char*));
! extern void perror _ARGS((const char *));
! extern int printf _ARGS((const char* format, ...));
! extern int puts _ARGS((const char *str));
! extern int remove _ARGS((const char*));
! extern int rename _ARGS((const char* _old, const char* _new));
! extern void rewind _ARGS((FILE*));
! extern int scanf _ARGS((const char* format, ...));
! extern void setbuf _ARGS((FILE*, char*));
! extern void setlinebuf _ARGS((FILE*));
! extern void setbuffer _ARGS((FILE*, char*, int));
! extern int setvbuf _ARGS((FILE*, char*, int mode, size_t size));
! extern int sprintf _ARGS((char*, const char* format, ...));
! extern int sscanf _ARGS((const char* string, const char* format, ...));
! extern FILE* tmpfile _ARGS((void));
! extern char* tmpnam _ARGS((char*));
! extern int ungetc _ARGS((int c, FILE* fp));
! extern int vfprintf _ARGS((FILE *fp, char const *fmt0, _G_va_list));
! extern int vprintf _ARGS((char const *fmt, _G_va_list));
! extern int vsprintf _ARGS((char* string, const char* format, _G_va_list));
  
! #if !defined(__STRICT_ANSI__) || defined(_POSIX_SOURCE)
! extern FILE *fdopen _ARGS((int, const char *));
! extern int fileno _ARGS((FILE*));
! extern FILE* popen _ARGS((const char*, const char*));
! extern int pclose _ARGS((FILE*));
! #endif
  
- extern int __underflow _ARGS((struct _IO_FILE*));
- extern int __overflow _ARGS((struct _IO_FILE*, int));
  
! #ifdef __cplusplus
! }
  #endif
  
  #endif /*!_STDIO_H*/
--- 90,183 ----
  #define stdout _IO_stdout
  #define stderr _IO_stderr
  
! __BEGIN_DECLS
  
! extern void clearerr __P((FILE*));
! extern int fclose __P((FILE*));
! extern int feof __P((FILE*));
! extern int ferror __P((FILE*));
! extern int fflush __P((FILE*));
! extern int fgetc __P((FILE *));
! extern int fgetpos __P((FILE* fp, fpos_t *pos));
! extern char* fgets __P((char*, int, FILE*));
! extern FILE* fopen __P((__const char*, __const char*));
! extern int fprintf __P((FILE*, __const char* format, ...));
! extern int fputc __P((int, FILE*));
! extern int fputs __P((__const char *str, FILE *fp));
! extern size_t fread __P((void*, size_t, size_t, FILE*));
! extern FILE* freopen __P((__const char*, __const char*, FILE*));
! extern int fscanf __P((FILE *fp, __const char* format, ...));
! extern int fseek __P((FILE* fp, long int offset, int whence));
! extern int fsetpos __P((FILE* fp, __const fpos_t *pos));
! extern long int ftell __P((FILE* fp));
! extern size_t fwrite __P((__const void*, size_t, size_t, FILE*));
! extern int getc __P((FILE *));
! extern int getchar __P((void));
! extern char* gets __P((char*));
! extern void perror __P((__const char *));
! extern int printf __P((__const char* format, ...));
! extern int putc __P((int, FILE *));
! extern int putchar __P((int));
! extern int puts __P((__const char *str));
! extern int remove __P((__const char*));
! extern int rename __P((__const char* _old, __const char* _new));
! extern void rewind __P((FILE*));
! extern int scanf __P((__const char* format, ...));
! extern void setbuf __P((FILE*, char*));
! extern void setlinebuf __P((FILE*));
! extern void setbuffer __P((FILE*, char*, int));
! extern int setvbuf __P((FILE*, char*, int mode, size_t size));
! extern int sprintf __P((char*, __const char* format, ...));
! extern int sscanf __P((__const char* string, __const char* format, ...));
! extern FILE* tmpfile __P((void));
! extern char* tmpnam __P((char*));
! extern int ungetc __P((int c, FILE* fp));
! extern int vfprintf __P((FILE *fp, char __const *fmt0, _G_va_list));
! extern int vprintf __P((char __const *fmt, _G_va_list));
! extern int vsprintf __P((char* string, __const char* format, _G_va_list));
  
! #if !defined(__STRICT_ANSI__) || defined(_POSIX_SOURCE)
! extern FILE *fdopen __P((int, __const char *));
! extern int fileno __P((FILE*));
! extern FILE* popen __P((__const char*, __const char*));
! extern int pclose __P((FILE*));
  #endif
  
! #if !defined(__STRICT_ANSI__)
! extern int getw __P((FILE*));
! extern int putw __P((int, FILE*));
  
! extern char* tempnam __P((__const char *__dir, __const char *__pfx));
  
  
! #ifdef __GNU_LIBRARY__
! 
! #ifdef  __USE_BSD
! extern int sys_nerr;
! extern char *sys_errlist[];
! #endif
! #ifdef  __USE_GNU
! extern int _sys_nerr;
! extern char *_sys_errlist[];
  #endif
+  
+ #ifdef  __USE_MISC
+ /* Print a message describing the meaning of the given signal number. */
+ extern void psignal __P ((int __sig, __const char *__s));
+ #endif /* Non strict ANSI and not POSIX only.  */
+ 
+ #endif /* __GNU_LIBRARY__ */
+ 
+ #endif /* __STRICT_ANSI__ */
+ 
+ extern int __underflow __P((struct _IO_FILE*));
+ extern int __overflow __P((struct _IO_FILE*, int));
+ 
+ #define getc(fp) _IO_getc(fp)
+ #define putc(c, fp) _IO_putc(c, fp)
+ #define putchar(c) putc(c, stdout)
+ #define getchar() getc(stdin)
+ 
+ __END_DECLS
  
  #endif /*!_STDIO_H*/
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/tempnam.c libg++-2.5.3linux.2/libio/stdio/tempnam.c
*** libg++-2.5.3/libio/stdio/tempnam.c	Wed Dec 31 19:00:00 1969
--- libg++-2.5.3linux.2/libio/stdio/tempnam.c	Mon Dec 20 08:54:35 1993
***************
*** 0 ****
--- 1,51 ----
+ /* Copyright (C) 1991, 1993 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+ 
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public License as
+ published by the Free Software Foundation; either version 2 of the
+ License, or (at your option) any later version.
+ 
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+ 
+ You should have received a copy of the GNU Library General Public
+ License along with the GNU C Library; see the file COPYING.LIB.  If
+ not, write to the Free Software Foundation, Inc., 675 Mass Ave,
+ Cambridge, MA 02139, USA.  */
+ 
+ #include <ansidecl.h>
+ #include <errno.h>
+ #include <stddef.h>
+ #include <stdlib.h>
+ #include <string.h>
+ #include "libioP.h"
+ #include "stdio.h"
+ 
+ 
+ /* Generate a unique temporary filename using up to five characters of PFX
+    if it is not NULL.  The directory to put this file in is searched for
+    as follows: First the environment variable "TMPDIR" is checked.
+    If it contains the name of a writable directory, that directory is used.
+    If not and if DIR is not NULL, that value is checked.  If that fails,
+    P_tmpdir is tried and finally "/tmp".  The storage for the filename
+    is allocated by `malloc'.  */
+ char *
+ DEFUN(tempnam, (dir, pfx), CONST char *dir AND CONST char *pfx)
+ {
+   _IO_size_t len;
+   register char *s;
+   register char *t = _IO_gen_tempname(dir, pfx, 1, &len, (_IO_FILE **) NULL);
+ 
+   if (t == NULL)
+     return NULL;
+ 
+   s = (char *) malloc(len);
+   if (s == NULL)
+     return NULL;
+ 
+   (void) memcpy(s, t, len);
+   return s;
+ }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/tmpfile.c libg++-2.5.3linux.2/libio/stdio/tmpfile.c
*** libg++-2.5.3/libio/stdio/tmpfile.c	Wed Dec 31 19:00:00 1969
--- libg++-2.5.3linux.2/libio/stdio/tmpfile.c	Mon Dec 20 08:54:35 1993
***************
*** 0 ****
--- 1,44 ----
+ /* Copyright (C) 1991, 1993 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+ 
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public License as
+ published by the Free Software Foundation; either version 2 of the
+ License, or (at your option) any later version.
+ 
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+ 
+ You should have received a copy of the GNU Library General Public
+ License along with the GNU C Library; see the file COPYING.LIB.  If
+ not, write to the Free Software Foundation, Inc., 675 Mass Ave,
+ Cambridge, MA 02139, USA.  */
+ 
+ #include <ansidecl.h>
+ #include "stdio.h"
+ #include "libioP.h"
+ 
+ 
+ /* This returns a new stream opened on a temporary file (generated
+    by tmpnam) The file is opened with mode "w+b" (binary read/write).
+    If we couldn't generate a unique filename or the file couldn't
+    be opened, NULL is returned.  */
+ FILE *
+ DEFUN_VOID(tmpfile)
+ {
+   char *filename;
+   _IO_FILE *f;
+ 
+   filename = _IO_gen_tempname((char *) NULL, "tmpf", 0,
+ 			      (_IO_size_t *) NULL, &f);
+   if (filename == NULL)
+     return NULL;
+ 
+   /* Note that this relies on the Unix semantics that
+      a file is not really removed until it is closed.  */
+   (void) remove (filename);
+ 
+   return f;
+ }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/tmpnam.c libg++-2.5.3linux.2/libio/stdio/tmpnam.c
*** libg++-2.5.3/libio/stdio/tmpnam.c	Wed Dec 31 19:00:00 1969
--- libg++-2.5.3linux.2/libio/stdio/tmpnam.c	Mon Dec 20 08:54:36 1993
***************
*** 0 ****
--- 1,46 ----
+ /* Copyright (C) 1991, 1993 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+ 
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public License as
+ published by the Free Software Foundation; either version 2 of the
+ License, or (at your option) any later version.
+ 
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+ 
+ You should have received a copy of the GNU Library General Public
+ License along with the GNU C Library; see the file COPYING.LIB.  If
+ not, write to the Free Software Foundation, Inc., 675 Mass Ave,
+ Cambridge, MA 02139, USA.  */
+ 
+ #include <ansidecl.h>
+ #ifdef __STDC__
+ #include <stddef.h>
+ #endif
+ #include "stdio.h"
+ #include "libioP.h"
+ #include <string.h>
+ 
+ 
+ /* Generate a unique filename in P_tmpdir.  */
+ char *
+ DEFUN(tmpnam, (s), register char *s)
+ {
+   register char *t = _IO_gen_tempname((CONST char *) NULL,
+ 					  (CONST char *) NULL, 0,
+ 					  (_IO_size_t *) NULL,
+ 				          (_IO_FILE **) NULL);
+ 
+   if (t == NULL)
+     return NULL;
+ 
+   if (s != NULL)
+     (void) strcpy(s, t);
+   else
+     s = t;
+ 
+   return s;
+ }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/vfprintf.c libg++-2.5.3linux.2/libio/stdio/vfprintf.c
*** libg++-2.5.3/libio/stdio/vfprintf.c	Fri Aug 20 02:00:01 1993
--- libg++-2.5.3linux.2/libio/stdio/vfprintf.c	Mon Feb 14 10:09:06 1994
***************
*** 22,27 ****
--- 22,37 ----
  This exception does not however invalidate any other reasons why
  the executable file might be covered by the GNU General Public License. */
  
+ #ifdef __linux__
+ 
+ #undef HAVE_GNU_LD
+ #define HAVE_GNU_LD
+ #include <gnu-stabs.h>
+ 
+ symbol_alias (_IO_vfprintf, vfprintf);
+ 
+ #else
+ 
  #include "libioP.h"
  
  int
***************
*** 30,35 ****
--- 40,48 ----
       char const *format;
       _IO_va_list args;
  {
+   CHECK_FILE(fp, -1);
    COERCE_FILE(fp);
    return _IO_vfprintf(fp, format, args);
  }
+ 
+ #endif
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/vfscanf.c libg++-2.5.3linux.2/libio/stdio/vfscanf.c
*** libg++-2.5.3/libio/stdio/vfscanf.c	Fri Nov 26 16:27:21 1993
--- libg++-2.5.3linux.2/libio/stdio/vfscanf.c	Mon Feb 14 10:09:14 1994
***************
*** 31,36 ****
--- 31,37 ----
       const char *format;
       _IO_va_list args;
  {
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    return _IO_vfscanf(fp, format, args, NULL);
  }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/strfile.h libg++-2.5.3linux.2/libio/strfile.h
*** libg++-2.5.3/libio/strfile.h	Wed Nov  3 15:00:05 1993
--- libg++-2.5.3linux.2/libio/strfile.h	Mon Dec 20 08:54:36 1993
***************
*** 27,34 ****
  Merge into  libio.h ?
  #endif
  
! typedef void *(*_IO_alloc_type) _PARAMS((_IO_size_t));
! typedef void (*_IO_free_type) _PARAMS((void*));
  
  struct _IO_str_fields
  {
--- 27,34 ----
  Merge into  libio.h ?
  #endif
  
! typedef void *(*_IO_alloc_type) __P((_IO_size_t));
! typedef void (*_IO_free_type) __P((void*));
  
  struct _IO_str_fields
  {
